# (C) 2019 anonymous authors. All rights reserved.

set (default_build_type "Release")
if (NOT (CMAKE_BUILD_TYPE_SHADOW STREQUAL CMAKE_BUILD_TYPE))
    if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
        message (STATUS "Setting build type to '${default_build_type}'")
        message (STATUS "  NOTE: You can choose a build type by calling cmake with one of:")
        message (STATUS "    -DCMAKE_BUILD_TYPE=Release   -- full optimizations")
        message (STATUS "    -DCMAKE_BUILD_TYPE=RelASan   -- full optimizations plus asan and ubsan")
        message (STATUS "    -DCMAKE_BUILD_TYPE=Debug     -- debug symbols, -Og")
        message (STATUS "    -DCMAKE_BUILD_TYPE=DebugASan -- debug plus asan and ubsan")
        set (CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
    else ()
        message (STATUS "Building in ${CMAKE_BUILD_TYPE} mode as requested.")
    endif ()
    set (CMAKE_BUILD_TYPE_SHADOW ${CMAKE_BUILD_TYPE} CACHE STRING "used to detect changes in build type" FORCE)
endif ()
